<?php

namespace LakeDrops\Ahoy;

use Composer\Script\Event;
use Composer\Script\ScriptEvents;
use LakeDrops\Component\Composer\BasePlugin;

/**
 * Composer plugin for handling Ahoy scripts.
 */
class Plugin extends BasePlugin {

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass() {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  public function getCapabilities(): array {
    return array(
      \Composer\Plugin\Capability\CommandProvider::class => CommandProvider::class,
    );
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    return array(
      ScriptEvents::POST_CREATE_PROJECT_CMD => 'updateScripts',
      ScriptEvents::POST_INSTALL_CMD => 'updateScripts',
      ScriptEvents::POST_UPDATE_CMD => 'updateScripts',
    );
  }

  /**
   * Update ahoy scripts of all LakeDrops plugins.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the plugin.
   */
  public function updateScripts(Event $event) {
    /** @var Handler $handler */
    $handler = $this->handler;
    $handler
      ->setEvent($event)
      ->updateScripts();
  }

}
